// =========================================================================================================================
// HiJack DInput
// =========================================================================================================================
#include <stdio.h>
#define DIRECTINPUT_VERSION 0x0800
#define CINTERFACE
#include "dinput.h"
#include "apihijack.h"

char DebugWork[256];
void DebugPrint(const char* Format, ... )
{
	_snprintf(DebugWork, sizeof(DebugWork), Format);
	OutputDebugString( DebugWork );
}

IDirectInput8Vtbl OldIDirectInput8Vtbl;
IDirectInputDevice8Vtbl OldIDirectInputDevice8Vtbl;

/*
HRESULT __stdcall IDirectInput8Hook_GetDeviceState(
	IDirectInputDevice8* _this, DWORD cbData, LPVOID lpvData 
)
{
	HRESULT ret = OldIDirectInputDevice8Vtbl.GetDeviceState( _this, cbData, lpvData );

	DWORD i;
	BYTE* input = (BYTE*)lpvData;
	if( ret == DI_OK ) 
	{
		if( input[DIK_F12] & 0x80 ) 
		{
			extern int RenderStyle;
			RenderStyle++;
			DebugPrint( "RenderStyle = %d Key = %.02x\n", RenderStyle, input[DIK_F12]&0x80 );
		}
	}

	return ret;
}
*/

void OnKey( DWORD Key, DWORD State );

HRESULT __stdcall IDirectInput8Hook_GetDeviceData(
	IDirectInputDevice8* _this, DWORD cbObjectData, LPDIDEVICEOBJECTDATA rgdod, LPDWORD pdwInOut, DWORD dwFlags )
{
	HRESULT ret = OldIDirectInputDevice8Vtbl.GetDeviceData( _this, cbObjectData, rgdod, pdwInOut, dwFlags );

	if( ret == DI_OK )
	{
		DWORD i;
		for(i = 0; i < cbObjectData; i++)
			OnKey( rgdod[i].dwOfs, rgdod[i].dwData );
	}

	return ret;
}

HRESULT __stdcall IDirectInput8Hook_CreateDevice( 
	IDirectInput8* _this, REFGUID rguid,                               
	LPDIRECTINPUTDEVICE8A *lplpDirectInputDevice,  
	LPUNKNOWN pUnkOuter )
{
	HRESULT ret = OldIDirectInput8Vtbl.CreateDevice( 
		_this, rguid, lplpDirectInputDevice, pUnkOuter );

	if ( rguid == GUID_SysKeyboard )
	{
		DebugPrint( "HiJacked Keyboard Device\n");
		IDirectInputDevice8* dev = *lplpDirectInputDevice;

		static bool IDirectInputDevice8Hooked = false;
		if ( !IDirectInputDevice8Hooked )
		{
			// Make a copy of the old Vtbl.
			memcpy( &OldIDirectInputDevice8Vtbl, dev->lpVtbl, sizeof(IDirectInputDevice8Vtbl) );

			// Hook functions.
			DWORD OldProtect;
			VirtualProtect( dev->lpVtbl, sizeof(IDirectInputDevice8Vtbl), PAGE_READWRITE, &OldProtect );
//			dev->lpVtbl->GetDeviceState = IDirectInput8Hook_GetDeviceState;
			dev->lpVtbl->GetDeviceData = IDirectInput8Hook_GetDeviceData;
			VirtualProtect( dev->lpVtbl, sizeof(IDirectInputDevice8Vtbl), OldProtect, &OldProtect );

			IDirectInputDevice8Hooked = true;
		}
	}
	return ret;
}


// ===========================================================================================================================

HRESULT WINAPI DirectInput8Create(HINSTANCE hinst, DWORD dwVersion, REFIID riidltf, LPVOID *ppvOut, LPUNKNOWN punkOuter);
typedef HRESULT (WINAPI *DirectInput8Create_Type)(HINSTANCE hinst, DWORD dwVersion, REFIID riidltf, LPVOID *ppvOut, LPUNKNOWN punkOuter);

enum
{
	DXFN_DirectInput8Create,
};

SDLLHook DInputHook = 
{
	"DINPUT8.DLL",
		false, 0,
	{
		{ "DirectInput8Create", DirectInput8Create },
		{ NULL, NULL }
	}
};

HRESULT WINAPI DirectInput8Create(HINSTANCE hinst, DWORD dwVersion, REFIID riidltf, LPVOID *ppvOut, LPUNKNOWN punkOuter)
{
    DirectInput8Create_Type OldFn = 
        (DirectInput8Create_Type)DInputHook.Functions[DXFN_DirectInput8Create].OrigFn;
    HRESULT ret = OldFn(hinst, dwVersion, riidltf, ppvOut, punkOuter);

    static bool IDirectInput8Hooked = false;
    if ( !IDirectInput8Hooked )
    {
		DebugPrint( "HiJacked Input Device\n");
		IDirectInput8* dev = (IDirectInput8*)*ppvOut;

        // Make a copy of the old Vtbl.
        memcpy( &OldIDirectInput8Vtbl, dev->lpVtbl, sizeof(IDirectInput8Vtbl) );

        // Hook functions.
		DWORD OldProtect;
		VirtualProtect( dev->lpVtbl, sizeof(IDirectInput8Vtbl), PAGE_READWRITE, &OldProtect );
        dev->lpVtbl->CreateDevice = IDirectInput8Hook_CreateDevice;
		VirtualProtect( dev->lpVtbl, sizeof(IDirectInput8Vtbl), OldProtect, &OldProtect );

        IDirectInput8Hooked = true;
    }

    return ret;
}